
#include <Wire.h>


#define   I2C_DEV_ADR     0x17 //адрес TM7K_I2C


byte Val = 0;


void setup()
{
  Serial.begin(9600);
  Wire.begin();
}

void loop()
{
  Val = 0;
  Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
  Wire.write(0x10); //команда выбора режима
  Wire.write(0x03); //SAM = 0; SPM = 1; RVM = 1; 
                    //отображаются все стрелки до текущей позиции
                    //возможно отображение отдельных составляющих стрелки
                    //отображается принятое значение
  Wire.endTransmission(); //стоп
  delay(100);

  for (byte i = 0; i < 22; i++)
  {
    Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
    Wire.write(0x20 | ((1 << Val) >> 8)); //команда записи значения для отображения + значение
    Wire.write((byte)(1 << Val));         //значение
    Wire.endTransmission(); //стоп
    delay(100);

    Val++;
    if (Val == 11)
    {
      Val = 0;
      Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
      Wire.write(0x20);        //команда записи значения для отображения + значение
      Wire.write(0);           //значение, все светодиоды не светятся
      Wire.endTransmission();  //стоп
      delay(100);
    }
  }

  Val = 0;
  Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
  Wire.write(0x10);        //команда выбора режима
  Wire.write(0x01);        //SAM = 0; SPM = 0; RVM = 1; 
                    //отображаются все стрелки до текущей позиции
                    //стрелка отображается только целиком, без разбиения на составляющие
                    //отображается принятое значение
  Wire.endTransmission();    //стоп
  delay(100);

  for (byte i = 0; i < 10; i++)
  {
    Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
    Wire.write(0x20);        //команда записи значения для отображения
    Wire.write(Val);          //значение  
    Wire.endTransmission();   //стоп
    delay(100);

    Val++;
    if (Val == 5)
    {
      Val = 0;
    }
  }
  
  Val = 0;
  Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
  Wire.write(0x10);        //команда выбора режима
  Wire.write(0x81);        //SAM = 1; SPM = 0; RVM = 1; 
                    //стрелка отображается только на текущей позиции
                    //стрелка отображается только целиком, без разбиения на составляющие
                    //отображается принятое значение  
  Wire.endTransmission();    //стоп
  delay(100);
  
  for (byte i = 0; i < 10; i++)
  {
    Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
    Wire.write(0x20);        //команда записи значения для отображения
    Wire.write(Val);          //значение  
    Wire.endTransmission();   //стоп
    delay(100);

    Val++;
    if (Val == 5)
    {
      Val = 0;
    }
  }

  Wire.beginTransmission(I2C_DEV_ADR); //старт, передача адреса + бит записи
  Wire.write(0x30);        //команда чтения показаний АЦП
  Wire.endTransmission();   //стоп
  delay(100);
  //чтение показаний АЦП
  unsigned int ADCData = 0;
  Wire.requestFrom(I2C_DEV_ADR, 2);    // старт, передача адреса + бит чтения
  for (byte i = 0; i < 2; i++)
    ADCData |= Wire.read() << (8 * i); //чтение данных
  
  Serial.println(ADCData); //вывод показаний АЦП
  Serial.println();
  delay(1000);
  
}







